<script setup>
import { ref, watch, provide } from 'vue'
import QuestionLine from '../components/QuestionLine.vue'
import Section from '../components/Section.vue'
import { defineRegexValidate, defineType } from '../data'
import questionsData from '../data/questions'
import sections from '../data/sections'
import optionsData from '../data/options'
import { useRouter } from 'vue-router'
import Complete from '../components/Complete.vue'

const userAnswers = ref([])
const router = useRouter()

const totalCost = ref(null)
const isShowCost = ref(false)

const section = ref(sections[0].name)

const getQuestionBySectionName = (userAnswers) => {
  return questionsData.filter(
    (item) => item.parent === section.value && item.isActive(userAnswers)
  )
}

const getTotalCost = () => {
  return userAnswers.value.reduce((pre, cur) => {
    if (cur.question.parent === 'contact') {
      return pre
    }

    if (cur.question.type == defineType.single) {
      const cost = +optionsData.find((item) => item.name === cur[cur.question.type])?.cost || 0
      return pre + cost
    }

    if (cur.question.type == defineType.multi) {
      let totalCost = cur[cur.question.type].reduce((pre1, cur1) => {
        const cost = +optionsData.find((item) => item.name === cur1)?.cost || 0
        console.log(cost, cur.question)
        return pre1 + cost
      }, 0)

      return pre + totalCost
    }

    return pre
  }, 0)
}

const questions = ref(getQuestionBySectionName())

const handlePreStep = () => {
  const index = sections.findIndex((item) => item.name === section.value)

  if (index <= 0) {
    router.push({ name: 'home' })
    return
  }
  section.value = sections[index - 1].name
}

const validate = (userAns) => {
  if (
    userAns.question.type == defineType.multi &&
    JSON.stringify(userAns[userAns.question.type]) === '[]'
  ) {
    return false
  }

  if (userAns.question.type != defineType.single && userAns.question.type !== defineType.multi) {
    if (userAns.question?.isEmpty) {
      return true
    }

    if (!defineRegexValidate[userAns.question.type]) {
      return true
    }

    const { value, message } = defineRegexValidate[userAns.question.type]
    if (!value.test(userAns[userAns.question.type])) {
      userAnswers.value = userAnswers.value.map((uAns) =>
        uAns.question.name === userAns.question.name ? { ...uAns, error: message } : uAns
      )
      return false
    } else {
      userAnswers.value = userAnswers.value.map((uAns) =>
        uAns.question.name === userAns.question.name ? { ...uAns, error: '' } : uAns
      )
    }
  }

  return true
}

const isValidateSuccess = () => {
  let check = true

  const userAns = userAnswers.value.filter((item) => item.question.parent === section.value)

  questions.value.forEach((question) => {
    if (!userAns.some((item) => item.question.name === question.name && validate(item))) {
      check = false
    }
  })

  return check
}

const handleNextStep = () => {
  const index = sections.findIndex((item) => item.name === section.value)
  if (!isValidateSuccess()) {
    return
  }

  if (section.value === 'contact') {
    return
  }

  if (index === sections.length - 2) {
    totalCost.value = getTotalCost()
    isShowCost.value = true
  }

  section.value = sections[index + 1].name
}

const handleUserAnswer = ({ question, ans }) => {
  let currentAns = [...userAnswers.value]
  if (currentAns.some((item) => item.question.name == question.name)) {
    currentAns = currentAns.map((item) =>
      item.question.name === question.name ? { ...item, [question.type]: ans } : item
    )
  } else {
    currentAns.push({ question: question, [question.type]: ans })
  }

  const currentQuestion = getQuestionBySectionName(currentAns)

  const newAns = currentAns.filter((item) => {
    if (item.question.parent !== section.value) {
      return true
    }

    const currentQuestionNames = []
    currentQuestion.forEach((cur) => currentQuestionNames.push(cur.name))
    if (!currentQuestionNames.includes(item.question.name)) {
      console.log('called', item.question.name)
      return false
    }

    return true
  })

  userAnswers.value = newAns
}

watch(section, () => {
  questions.value = getQuestionBySectionName(userAnswers.value)
})

watch(userAnswers, () => {
  questions.value = getQuestionBySectionName(userAnswers.value)
})
</script>

<template>
  <div
    class="max-w-[1200px] mx-auto px-2 flex-1 flex flex-col justify-center pt-2 pb-[100px] w-full"
  >
    <template v-if="!totalCost">
      <div>
        <Section
          :userAnswers="userAnswers"
          :questions="questions"
          :section="sections.find((item) => item.name === section)"
          :handleUserAnswer="handleUserAnswer"
        />
      </div>
      <div
        class="flex items-center gap-4 fixed bottom-0 left-0 right-0 max-w-[1200px] px-2 mx-auto py-4"
      >
        <el-button size="large" class="mt-4" @click="handlePreStep()">
          <el-icon class="el-icon--right" :size="25"><Back /></el-icon
        ></el-button>
        <QuestionLine
          :total="sections.length - 1"
          :current="sections.findIndex((item) => item.name === section) + 1"
        />
        <el-button plain size="large" class="mt-4" @click="handleNextStep()" type="primary"
          >Continue <el-icon class="el-icon--right"><Right /></el-icon
        ></el-button>
      </div>
    </template>
    <template v-if="totalCost">
      <div>
        <h1 class="font-bold leading-10 text-4xl mb-4">Rough Estimate of my MVP</h1>

        <div class="flex flex-col md:flex-row gap-2">
          <Complete :totalCost="totalCost" />
          <div class="flex-1 bg-[#F8FBFD] p-10 rounded">
            <Section
              :userAnswers="userAnswers"
              :questions="questions"
              :section="sections.find((item) => item.name === section)"
              :handleUserAnswer="handleUserAnswer"
            />
            <el-button
              size="large"
              class="mt-4 w-full max-w-sm"
              @click="handleNextStep()"
              type="primary"
              >Continue <el-icon class="el-icon--right"><Right /></el-icon
            ></el-button>
          </div>
        </div>
      </div>
    </template>
  </div>
</template>
